require "polylink_api/version"
require "polylink_api/configuration"
require "polylink_api/helper"
require "polylink_api/did"
require "polylink_api/models/log"
require "logger"
require "mongoid"

module PolylinkApi
  Error                 = Class.new(RuntimeError)
  InvalidResponseError  = Class.new(Error)
  AuthenticationError   = Class.new(Error)
  InvalidMethodError    = Class.new(Error)
  InvalidParameterError = Class.new(Error)
  InvalidDataError      = Class.new(InvalidParameterError)
  NotExistError         = Class.new(InvalidDataError)
  AlreadyExistedError   = Class.new(InvalidDataError)
  UnknownError          = Class.new(Error)

  def self.setup
    yield config
  end

  def self.config
    @config ||= Configuration.new
  end

  def self.logger
    @logger ||= Logger.new(STDOUT)
  end
end